/* ------------------------------------------------- */
/*                   BACKCOPY.C                      */
/*   Routine zum Konvertieren von Dateien, die mit   */
/*            "Backup" gesichert wurden.             */
/*    (c) 1988 by Dieter Hartebrodt & PASCAL Int.    */
/* ------------------------------------------------- */
#include <stdio.h>

main(argc,argv)
int argc;
char *argv[];
{
  int ch;
  FILE *fbackup,*fziel;

  if(argc < 3)
  {
    printf("Nicht gengend Argumente in der ");
    printf("Kommandozeile\n");
    printf("Aufruf: backcopy <pfad>\<Backupdateiname> ");
    printf("<pfad>\<name>\n");
    exit(0);
  }

  if(strcmp(argv[1],argv[2]) == 0)
  {
    printf("Bitte Argumente ('%s' <--> '%s') ");
    printf("berprfen!\n",argv[1],argv[2]);
    printf("Datei kann nicht in sich selbst kopiert ");
    printf("werden!\n");
    exit(0);
  }

  if(!f_exist(argv[1]))
  {
  printf("Backupdatei '%s' existiert nicht!",argv[1]);
  exit(0);
  }

  if(!f_exist(argv[2]))
  {
    printf("\nZieldatei '%s' wird angelegt!\n",argv[2]);
    printf("Backupdatei '%s' wird kopiert!\n",argv[1]);
  }
  else
  {
    printf("\nZieldatei '%s' existiert bereits!\n",
					      argv[2]);
    printf("Soll die Backupdatei '%s'angehngt ");
    printf("werden? j/n",argv[1]);
    if(tolower(getch()) != 'j')
      exit(0);
  }

  fbackup = fopen(argv[1],"rb");     /*Dateien ffnen*/
  fziel = fopen(argv[2],"ab+");

  fseek(fbackup,0x80L,SEEK_SET);     /* Dateizeiger  */
				     /*positionieren */
  while((ch=fgetc(fbackup)) != EOF)  /*  Kopieren    */
    fputc(ch,fziel);

  fclose(fbackup);
  fclose(fziel);
}

int f_exist(filename)
char *filename;
{
  FILE *fd;
  if((fd = fopen(filename,"r")) == NULL)
    return(0);
  else
  {
    fclose(fd);
    return(1);
  }
}
/* ------------------------------------------------- */
/*               Ende von BACKCOPY.C                 */

